package com.example.cdi.controller;

import com.example.cdi.event.CustomerUpdatedEvent;
import com.example.cdi.model.Customer;
import com.example.cdi.qualifier.PremiumCustomer;
import com.example.cdi.qualifier.StandardCustomer;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Event;
import javax.inject.Inject;
import javax.inject.Named;

@Named
@RequestScoped
public class CustomerController {

    @Inject
    @StandardCustomer
    private Customer standardCustomer;

    @Inject
    @PremiumCustomer
    private Customer premiumCustomer;

    @Inject
    @PremiumCustomer
    Event<CustomerUpdatedEvent> event;

    public Customer getStandardCustomer() {
        return standardCustomer;
    }

    public void setStandardCustomer(Customer standardCustomer) {
        this.standardCustomer = standardCustomer;
    }

    public Customer getPremiumCustomer() {
        return premiumCustomer;
    }

    public void setPremiumCustomer(Customer premiumCustomer) {
        this.premiumCustomer = premiumCustomer;
    }

    public String updateCustomerData() {
        CustomerUpdatedEvent customerUpdatedEvent = new CustomerUpdatedEvent();
        customerUpdatedEvent.setCustomer(premiumCustomer);
        event.fire(customerUpdatedEvent);
        return "confirmation";
    }

}
