package com.example.ejb;

import java.util.concurrent.Future;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.AsyncResult;
import javax.ejb.Asynchronous;
import javax.ejb.Stateless;

@Stateless
public class AsynchSessionBean {

    private static final Logger LOGGER = Logger.getLogger(
            AsynchSessionBean.class.getName());

    @Asynchronous
    public void slowMethod() {
        long startTime = System.currentTimeMillis();
        LOGGER.info("entering slowMethod()");
        try {
            Thread.sleep(10000); //simulate processing for 10 seconds
        } catch (InterruptedException ex) {
            LOGGER.log(Level.SEVERE, null, ex);
        }
        LOGGER.info("leaving slowMethod()");
        long endTime = System.currentTimeMillis();
        LOGGER.log(Level.INFO, "execution took {0} milliseconds",
                (endTime - startTime));
    }

    @Asynchronous
    public Future<Long> slowMethodWithReturnValue() {
        LOGGER.info("entering slowMethodWithReturnValue()");
        try {

            Thread.sleep(2000);
        } catch (InterruptedException ex) {
            LOGGER.log(Level.SEVERE, null, ex);
        }
        LOGGER.info("leaving slowMethodWithReturnValue()");
        return new AsyncResult<Long>(42L);
    }
}
