package com.example.ejb;

import java.time.LocalDateTime;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.ejb.Schedule;

@Stateless
@LocalBean
public class ScheduledSessionBean {

    private static final Logger LOG = Logger.getLogger(ScheduledSessionBean.class.getName());

    @Schedule(hour = "*", minute = "*", second = "*/10")
    public void logMessage() {
        LOG.log(Level.INFO, "{0}.logMessage() invoked at {1}", new Object[]{this.getClass().getCanonicalName(), LocalDateTime.now()});
    }
}
