package com.example.cdi;

import com.example.ejb.AsynchSessionBean;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;

@Named
@RequestScoped
public class AsynchClientBean {

    private static final Logger LOGGER
            = Logger.getLogger(AsynchClientBean.class.getName());

    private Long returnVal;

    @EJB
    private AsynchSessionBean asynchSessionBean;

    public String fireAndForget() {

        LOGGER.info("invoking slowMethod()");
        asynchSessionBean.slowMethod();
        LOGGER.info("after slowMethod() invocation");
        return "slowmethod_confirmation";
    }

    public String asynchReturnValue() {
        LOGGER.info("invoking slowMethodWithReturnValue()");
        Future<Long> retVal
                = asynchSessionBean.slowMethodWithReturnValue();
        LOGGER.info("after slowMethodWithReturnValue() invocation");
        try {
            returnVal = retVal.get(5, TimeUnit.SECONDS);
        } catch (TimeoutException ex) {
            return "retval_timeout";
        } catch (InterruptedException | ExecutionException ex) {
            Logger.getLogger(AsynchClientBean.class.getName()).log(Level.SEVERE, null, ex);
        }

        return "retval_success";
    }

    public Long getReturnVal() {
        return returnVal;
    }

    public void setReturnVal(Long returnVal) {
        this.returnVal = returnVal;
    }

}
